;************************************************
;LEKCJA  13	- STEROWNIK TRANSMISJI SZEREGOWEJ
;PRZYKAD 4	- BUFORY NADAWCZE I ODBIORCZE
;************************************************

;******* Pami wewntrzna RAM ********
B1R2	EQU	8+2		;rejestr 2 w banku 1
B1R3	EQU	8+3		;rejestr 3 w banku 1

FLAGA	EQU	20H		;zestaw flag bitowych
NADAJE EQU	FLAGA.0		;trwa nadawanie znaku

BUFOR	EQU	10H		;wielko bufora

BUF_N	EQU	30H		;bufor nadawczy
BUF_NE EQU	BUF_N+BUFOR	;koniec buf. nad.
BUF_O	EQU	BUF_NE		;bufor odbiorczy
BUF_OE EQU	BUF_O+BUFOR	;koniec buf. odb.

STOS	EQU	60H		;pozycja stosu

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	0	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	2	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;******* Transmisja Szeregowa *********
TR_M	EQU	1	;tryb transmisji (1..3)
TR_R	EQU	1	;zezwolenie na odbir

SCON_SET	EQU	TR_M*64+TR_R*16

;SMOD=1
;TIMER1=57600/300bodw=192
TH1_SET		EQU	256-192
TL1_SET		EQU	256-192

;************** MACRA *****************
BANK0	MACRO		;ustawienie banku 0 rejestrw
	CLR	RS0	;(z banku 1)
	MACEND

BANK1	MACRO		;ustawienie banku 1 rejestrw
	SETB	RS0	;(z banku 0)
	MACEND

;**************************************
	LJMP	START

;********* Przerwanie RS 232 **********
	ORG	23H
	PUSH	ACC
	PUSH	PSW
	BANK1

	JBC	TI,NAD		;koniec nadania znaku
	CLR	RI		;znak odebrany
	MOV	@R1,SBUF	;wpisz do buf. odb.
	INC	R3		;zwiksz licznik
	INC	R1		;zwiksz adres wpisu
	CJNE	R1,#BUF_OE,ODB_E
	MOV	R1,#BUF_O	;zaptlenie bufora

ODB_E:
	POP	PSW
	POP	ACC
	RETI	

NAD:				;nadaj nastpny znak
	CJNE	R2,#0,NAD_N	;czy jest w buforze

	CLR	NADAJE		;nie - koniec nadawania
	POP	PSW
	POP	ACC
	RETI	

NAD_N:
	MOV	SBUF,@R0	;nadanie nastpnego znaku
	DEC	R2		;zmniejsz licznik
	INC	R0		;zwiksz adres pobierania
	CJNE	R0,#BUF_NE,NAD_E
	MOV	R0,#BUF_N	;zaptlenie bufora
NAD_E:
	POP	PSW
	POP	ACC
	RETI	

;**************************************
	ORG	100H
START:
	MOV	SP,#STOS

	MOV	SCON,#SCON_SET		;port szeregowy
	ORL	PCON,#80H		;SMOD=1
	MOV	TMOD,#TMOD_SET		;Timer 1 dla
	MOV	TH1,#TH1_SET		;transmisji	
	MOV	TL1,#TL1_SET
	SETB	TR1			;start Timera 1

	CLR	NADAJE		;nie trwa nadawanie
	
	MOV	R0,#BUF_N	;ustawienie adresw
	MOV	R1,#BUF_O	;wpisu i pobierania
	BANK1			;dla buforw
	MOV	R0,#BUF_N
	MOV	R1,#BUF_O
	MOV	R2,#0
	MOV	R3,#0
	BANK0


	SETB	EA		;zezwolenie na przerwanie
	SETB	ES		;z transmisji szeregowej

	LCALL	LCD_CLR
LOOP:
	MOV	A,B1R3		;czy bufor odbioru pusty
	JZ	ODB_NO
	MOV	A,@R1		;nie - wypisz znak
	LCALL	WRITE_DATA
	DEC	B1R3		;zmniejsz licznik
	INC	R1		;zwiksz adres pobierania
	CJNE	R1,#BUF_OE,LOOP
	MOV	R1,#BUF_O	;zaptlenie bufora
	SJMP	LOOP

ODB_NO:
	LCALL	TEST_ENTER	;czy trzeba nadawa
	JC	LOOP

	MOV	DPTR,#TEXT	;nadaj text
LP1:
	CLR	A
	MOVC	A,@A+DPTR	;pobierz znak
	JZ	LOOP		;0 - koniec textu

	PUSH	ACC		;czy jest miejsce
	MOV	A,#BUFOR	;w buforze nadawczym
LP2:
	CJNE	A,B1R2,LP3
	SJMP	LP2
LP3:
	POP	ACC

	MOV	@R0,A		;wpisz znak do bufora
	INC	R0		;zwiksz adres wpisu
	INC	B1R2		;zwiksz licznik

	JB	NADAJE,LP4	;inicjuj nadawanie
	SETB	NADAJE		;jeli nie trwa
	SETB	TI
LP4:
	INC	DPTR		;nastpny znak w tekcie
	CJNE	R0,#BUF_NE,LP1
	MOV	R0,#BUF_N	;zaptlenie bufora nad.
	SJMP	LP1

TEXT:
	DB	'MicroMade',0
