;************************************************
;LEKCJA  15	- STEROWNIK PRZERWA DSM-51
;PRZYKAD 1	- NADAWANIE RS-485
;************************************************

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	2	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;******* Transmisja Szeregowa *********
;Timer/Bit = Fosc[Hz] /12 /V[bod]
BIT_TIME	EQU	11059200/12/4800
T0_SET		EQU	256-BIT_TIME
OUT		EQU	P1.2
OUT_EN		EQU	P1.3
;**************************************

	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH

	PUSH	PSW
	PUSH	ACC
	DJNZ	R2,NEXT
				;koniec transmisji bajtu
	SETB	OUT		;bit stopu
	CLR	TR0		;stop Timer 0
	POP	ACC
	POP	PSW
	RETI

NEXT:				;kolejny bit transmisji
	MOV	A,R7
	RRC	A
	MOV	OUT,C		;bit na port
	MOV	R7,A
	POP	ACC
	POP	PSW
	RETI

;***************************************
	ORG	100H
START:

	MOV	TMOD,#TMOD_SET		;Timer 0 dla
	MOV	TH0,#T0_SET		;transmisji	
	MOV	TL0,#T0_SET
	CLR	OUT_EN			;wcz nadajnik RS485
	SETB	EA			;wcz przerwanie
	SETB	ET0			;od Timera 0

	LCALL	LCD_CLR
LOOP:
	LCALL	WAIT_KEY
	ADD	A,#30H
	MOV	R7,A			;znak do nadania
	MOV	R2,#9			;licznik bitw
	CLR	OUT			;bit startu
	SETB	TR0			;start Timera 0
	LCALL	WRITE_DATA		;wywietl na LCD
	SJMP	LOOP			
