;************************************************
;LEKCJA  16	- UKAD TRANSMISJI RWNOLEGEJ 8255
;PRZYKAD 3	- TRYB 1 - PORT A -> PORT B
;************************************************

;********** Ustawienie 8255 ***********
;Transmisja rwnolega z portu A do portu B

PA_M	EQU	1	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	1	;TRYB 0..1
PB_D	EQU	1	;OUT->0, IN->1
PCB_D	EQU	0	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

INT55	EQU	P1.1	;uaktywnienie przerwa 8255

;**************************************
	LJMP	START

;********* Przerwanie INT 1 ***********
	ORG	13H
	PUSH	ACC
	PUSH	PSW
	MOV	A,R0
	PUSH	ACC

	MOVX	A,@R1		;odczyt numeru przerwania
	ANL	A,#03H
	MOVX	@R1,A		;skasowanie przerwania

	CJNE	A,#3,INT_NO3
	MOV	R0,#CS55B	;przerwanie IPB - odbir
	MOVX	A,@R0		;odebrane dane na LCD
	LCALL	WRITE_DATA

	MOV	A,#3		;skasowanie przerwania
	SJMP	INTX_END	;w sterowniku przerwa

INT_NO3:
	CJNE	A,#2,INT_END
	JNB	T1,NAD_END	;przerwanie IPA - nad.

	INC	R2		;nadanie kolejnego znaku
	MOV	A,R2		;przez PORT A
	MOV	R0,#CS55A
	MOVX	@R0,A

	SJMP	INT2_END

NAD_END:
	CLR	B.0		;koniec nadawania
	MOV	A,#6*2		;blokada przerwa IPA
	MOVX	@R0,A		;przez zapis 0 do INTEa

INT2_END:
	MOV	A,#2		;skasowanie przerwania
INTX_END:
	MOVX	@R1,A		;w sterowniku przerwa

INT_END:
	POP	ACC
	MOV	R0,A
	POP	PSW
	POP	ACC
	RETI	

;**************************************
	ORG	0100H
START:
	LCALL	LCD_CLR

	MOV	R0,#CSDS	;wybr klawisza [<-']
	MOV	A,#1
	MOVX	@R0,A

	MOV	R0,#CS55D	;inicjalizacja 8255
	MOV	A,#SET_8255
	MOVX	@R0,A

;**************************************
	CLR	INT55		;uaktywnienie sterownika
				;na przerwania z 8255
	MOV	R1,#CSAD	;skasowanie przerwania
	MOVX	A,@R1		;z przetwornika A/C

	MOV	R1,#CSIC	;skasowanie przerwa
	CLR	A		;w sterowniku przerwa
	MOVX	@R1,A
	INC	A
	MOVX	@R1,A
	INC	A
	MOVX	@R1,A
	INC	A
	MOVX	@R1,A

	SETB	EA		;wczenie przerwa
	SETB	EX1		;z wejcia INT1

	MOV	A,#2*2+1	;wczenie przerwa IPB
	MOVX	@R0,A		;przez zapis 1 do INTEb

;**************************************
	MOV	R2,#0		;kolejno nadawane znaki
LOOP:
	JNB	T1,$		;oczekiwanie na klawisz 
	SETB	B.0		;[<-']
	MOV	A,#6*2+1	;wczenie przerwa IPA
	MOVX	@R0,A		;przez zapis 1 do INTEa
	JB	B.0,$		;czekaj na zwolnienie
				;klawisza - koniec nadaw.
	SJMP	LOOP
