;************************************************
;LEKCJA  17	- PRZETWARZANIE A/C I C/A
;PRZYKAD 4	- STEROWANIE WYPENIENIEM
;************************************************

;********** Ustawienie 8255 ***********
;PORT A -> PA0 - wyjcie na filtr RC

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	0	;OUT->0, IN->1
PCB_D	EQU	0	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	1	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;**************************************

	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH
	CPL	F0		;flaga stanu wyjcia
	PUSH	PSW
	PUSH	ACC
	JB	F0,OUT_1

	MOV	TH0,R6		;okres 0 na wyjciu
	MOV	A,#0
	MOVX	@R1,A
	POP	ACC
	POP	PSW
	RETI

OUT_1:				;okres 1 na wyjciu
	MOV	TH0,R7
	MOV	A,#1
	MOVX	@R1,A
	POP	ACC
	POP	PSW
	RETI

;**************************************
	ORG	100H
START:
	MOV	R1,#CS55D
	MOV	A,#SET_8255
	MOVX	@R1,A
	MOV	R1,#CS55A

	LCALL	LCD_CLR
	MOV	TMOD,#TMOD_SET		;Timer 0 liczy czas
	SETB	EA		;wcz zezwolenie na
	SETB	ET0		;przerwanie od Timera 0

	SJMP	STOP_0		;na pocztek 0 na wyjcie

LOOP:
	LCALL	WAIT_KEY	;numer klawisz 0..15
	MOV	R2,A		;jako wypenienie
	LCALL	LCD_CLR
	MOV	A,R2
	LCALL	WRITE_HEX	;wpisz na LCD
	MOV	A,R2

	JZ	STOP_0		;dla 0 i 15 zatrzymaj
	CPL	A		;timery, na wyjcie
	INC	A		;odpowiednio stan 0 lub 1
	MOV	R7,A		;dla 1..14 wpisz:
	ADD	A,#0FH		;do R7 okres stanu 1
	JZ	STOP_1		;a do R6 okres stanu 0
	CPL	A
	INC	A
	MOV	R6,A
	SETB	TR0		;start Timera 0
	SJMP	LOOP

STOP_0:
	CLR	TR0		;stop Timera 0
	MOV	A,#0		;0 na wyjcie
	MOVX	@R1,A
	SJMP	LOOP
	
STOP_1:
	CLR	TR0		;stop Timera 0
	MOV	A,#1		;1 na wyjcie
	MOVX	@R1,A
	SJMP	LOOP
