;************************************************
;LEKCJA  19	- PAMI EEPROM
;PRZYKAD 1	- ODCZYT
;************************************************

;********** Ustawienie 8255 ***********
;PORT C -> EEPROM
;PC7 -> CS
;PC6 -> SK
;PC5 -> DI
;PC3 <- DO

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	0	;OUT->0, IN->1
PCB_D	EQU	1	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

;********* Instrukcje EEPROMU *********
READ	EQU	80H	;odczyt

;************** MACRA *****************
CLOCK	MACRO			;impuls na PC6 (SK)
	MOV	A,#6*2+1
	MOVX	@R0,A
	DEC	A
	MOVX	@R0,A
	MACEND

CS_ON	MACRO			;wczenie sygnau CS
	MOV	A,#7*2+1
	MOVX	@R0,A
	MACEND

CS_OFF MACRO			;wyczenie sygnau CS
	MOV	A,#7*2
	MOVX	@R0,A
	MACEND

DI_1	MACRO			;linia danych=1
	MOV	A,#5*2+1
	MOVX	@R0,A
	MACEND

DI_0	MACRO			;linia danych=0
	MOV	A,#5*2
	MOVX	@R0,A
	MACEND

;**************************************
	LJMP	START
	ORG	100H
START:

	MOV	R0,#CS55D	;inicjalizacja 8255
	MOV	A,#SET_8255
	MOVX	@R0,A

	DEC	R0
	MOV	A,#0H		;CS=0, SK=0, DI=0
	MOVX	@R0,A
	INC	R0

	LCALL	LCD_CLR

LOOP:
	LCALL	WAIT_KEY	;adres w pamici EEPROM
	PUSH	ACC
	LCALL	LCD_CLR
	MOV	A,#'('
	LCALL	WRITE_DATA
	POP	ACC
	PUSH	ACC
	LCALL	WRITE_HEX	;wypisz adres na LCD
	MOV	DPTR,#TEXT
	LCALL	WRITE_TEXT

	CS_ON
	CLOCK
	DI_1			;bit startu
	CLOCK
	POP	ACC		;adres uzupeniony
	SETB	ACC.7		;instrukcj READ
	ACALL	WR_8B		;wysanie instrukcji
	DI_0			;z adresem
	ACALL	RD_8B		;odczyt 16 bitw danych
	LCALL	WRITE_HEX
	ACALL	RD_8B
	LCALL	WRITE_HEX
	CS_OFF			

	SJMP	LOOP

;*********** PODPROGRAMY **************
WR_8B:				;zapis 8 bitw do EEPROMu
	MOV	R7,#8
W_LOOP:
	RLC	A		;kolejny bit do C
	PUSH	ACC

	MOV	A,#5		;bit 5 w porcie C - DI
	RLC	A		;dodanie wartoci bitu
	MOVX	@R0,A		;wysanie na port C
	CLOCK			;wpis bitu do EEPROMu

	POP	ACC
	DJNZ	R7,W_LOOP
	RET

;******************
RD_8B:				;odczyt 8 bitw z EEPROMu
	MOV	R7,#8
R_LOOP:
	PUSH	ACC

	CLOCK
	DEC	R0		;adres w R0 na port C
	MOVX	A,@R0
	MOV	C,ACC.3		;odczyt linii DO
	INC	R0

	POP	ACC
	RLC	A		;skadanie caego bajtu
	DJNZ	R7,R_LOOP
	RET

;******************
TEXT:
	DB	') = ',0
